Subject: Re: bug#30955: 27.0.50; Mouse clicks on header-line in Info are broken

From: Stefan Monnier <[email-masked]>
Date: Thu, 29 Mar 2018 08:10:03 -0400

>> >         Stefan "not looking forward to debug sessions in read_key_sequence"
>> Ha, I found the sucker!
>> Installed,
> Thanks.  The original bug is fixed, but I still don't understand
> something related.  If I do "C-h c" and click mouse-1 on the Up link
> on the header-line, I see this in the echo area:
>
>   <header-line> <down-mouse-1> (translated from <down-mouse-1>) at that spot
> runs the command mouse-drag-header-line
>   <header-line> <mouse-2> (translated from <mouse-2>) at that spot runs the
> command Info-mouse-follow-link
>
> Why does the second line talk about mouse-2?  I didn't click that
> button.  I'd expect to see only mouse-1 mentioned in both lines.

To figure out what that click would run (Info-mouse-follow-link in this
case), we have to perform the same translation as if you actually
performed the action.

There's indeed a bug, here, which is that it says

    (translated from <mouse-2>)

instead of

    (translated from <mouse-1>)

I assume it's because the fix I installed modifies the event in-place,
so the recording of "untranslated events" gets changed by side-effect.
Maybe we should record *copies* of events in there, to avoid this?

        Stefan